#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityHappySummerBlindBoxCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityHappySummerBlindBoxCFG> M_ActivityHappySummerBlindBoxCFG::msSingleton(nullptr);

int M_ActivityHappySummerBlindBoxCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityHappySummerBlindBoxCFGData* M_ActivityHappySummerBlindBoxCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityHappySummerBlindBoxCFGData>& M_ActivityHappySummerBlindBoxCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityHappySummerBlindBoxCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityHappySummerBlindBoxCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityHappySummerBlindBoxCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mItemID = element->IntAttribute("ItemID");
		data.mCount = element->IntAttribute("Count");
		data.mRemainder = element->IntAttribute("Remainder");
		data.mBIgPrice = element->IntAttribute("BIgPrice");
		data.mWeight1 = element->IntAttribute("Weight1");
		data.mWeight2 = element->IntAttribute("Weight2");
		data.mWeight3 = element->IntAttribute("Weight3");
		data.mWeight4 = element->IntAttribute("Weight4");
		data.mWeight5 = element->IntAttribute("Weight5");
		data.mWeight6 = element->IntAttribute("Weight6");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityHappySummerBlindBoxCFG::Load()
{
	Load("../Config/M_ActivityHappySummerBlindBoxCFG.xml");
}

M_ActivityHappySummerBlindBoxCFG* M_ActivityHappySummerBlindBoxCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityHappySummerBlindBoxCFG());
	}
	return msSingleton.get();
}
